<?php

var_dump($_FILES);
$uploaddir = dirname(__FILE__) . DIRECTORY_SEPARATOR . "uploads";
if (!file_exists($uploaddir)) {
    mkdir($uploaddir, 0777, true);
}

echo("Upload folder is: " . $uploaddir . "<br>\n");

if(!isset($_FILES['file']['name']))
	die('No file be uploaded.');
if(empty($_FILES['file']['name']))
	die('filename is empty.');

$name=$_FILES['file']['name'];
$size=$_FILES['file']['size'];
$type=$_FILES['file']['type'];
$tmp_name=$_FILES['file']['tmp_name'];
$error=$_FILES['file']['error'];
$maxsize=100*1024*1024;
$date = date('Ymd-His');
$uploadfile = $uploaddir . DIRECTORY_SEPARATOR . basename( $_FILES['file']['name']);

// perform any security check here...
if($size > $maxsize)
	die("File size is too big.");

if(!move_uploaded_file($tmp_name, $uploadfile))
	die("There was an error uploading the file: $uploadfile". "<br>\n");
echo "The file has been uploaded successfully: $uploadfile, we will process file continue.<br>\n";

//Unzip file to a folder
$strZIPFolder = substr($uploadfile, 0, strrpos($uploadfile, '.'));

$zip = new ZipArchive;
$res = $zip->open($uploadfile);
if ($res === TRUE)
{
	$zip->extractTo($strZIPFolder);
	$zip->close();
	echo "WOOT! $file extracted to $strZIPFolder". "<br>\n";
} else {
	die("Doh! I couldn't open $file, maybe something is wrong during uploading.<br>\n");
}

//Read ini file from folder
$arrFiles = scandir($strZIPFolder);
var_dump($arrFiles);

$arrFilesByKeyAndValue = array();
foreach ($arrFiles as $strItemFile)
{
	if($strItemFile == '.' || $strItemFile == '..')
		continue;
	$path_parts = pathinfo($strItemFile);
	$arrFilesByKeyAndValue[] = $strZIPFolder . DIRECTORY_SEPARATOR . $strItemFile;
}
var_dump($arrFilesByKeyAndValue);


$strIniFile = '';
foreach ($arrFilesByKeyAndValue as $strItemFile)
{
	$path_parts = pathinfo($strItemFile);
	if($path_parts['extension'] == 'ini')
	{
		if( strpos(file_get_contents($strItemFile), '[VeryPDFPrinterInfo]') !== false) {
			$strIniFile = $strItemFile;
			break;
		}
	}
}


$ini_array = parse_ini_file($strIniFile);
var_dump($ini_array);
foreach ($ini_array as $key=>$value)
{
	$ini_array[$key] = hexToStr($value);
}
var_dump($ini_array);

$strUploadedFiles = print_r($arrFilesByKeyAndValue, true);
$strMessageBoxBegin = "[MessageBoxBegin]";
$strMessageBoxEnd = "[MessageBoxEnd]";
$strMessageToClient = "Thank you for upload files to web server, the files are:\n\n";
echo($strMessageBoxBegin . $strMessageToClient . $strUploadedFiles . $strMessageBoxEnd);


/////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////
/** 
* Automatic judgment gbk or gb2312 Converts the encoded string to utf8 
* Can automatically determine the encoding class of the input string if itself is utf-8 I don't have to convert it, otherwise I just convert it utf-8 The string  
* The supported character encoding types are: utf-8,gbk,gb2312 
*@$str:string  string  
*/ 

function is_utf8($str) {
    $strlen = strlen($str);
    for ($i = 0; $i < $strlen; $i++) {
        $ord = ord($str[$i]);
        if ($ord < 0x80) continue; // 0bbbbbbb
        elseif (($ord & 0xE0) === 0xC0 && $ord > 0xC1) $n = 1; // 110bbbbb (exkl C0-C1)
        elseif (($ord & 0xF0) === 0xE0) $n = 2; // 1110bbbb
        elseif (($ord & 0xF8) === 0xF0 && $ord < 0xF5) $n = 3; // 11110bbb (exkl F5-FF)
        else return false; // invalid UTF-8-Zeichen
        for ($c=0; $c<$n; $c++) // $n following bytes? // 10bbbbbb
            if (++$i === $strlen || (ord($str[$i]) & 0xC0) !== 0x80)
                return false; // invalid UTF-8 char
    }
    return true; // didn't find any invalid characters
}
function to_utf8($str) {
	//return is_utf8($str) ? $str : utf8_encode($str);
	return is_utf8($str) ? $str : iconv('GB2312','UTF-8',$str);
}

function RemoveSpecialChar($str)
{
	$arrayCharacters = array( '\'', '|', ',', ';', '<', '>', '[', ']', '`');
	$res = str_replace($arrayCharacters, '-', $str);
	return $res;
}
function rrmdir($dir)
{ 
   printf("rrmdir: Try to Detele Folder: %s\n" , $dir);
   if (is_dir($dir)) { 
     $objects = scandir($dir);
     foreach ($objects as $object) { 
       if ($object != "." && $object != "..") { 
         if (is_dir($dir. DIRECTORY_SEPARATOR .$object) && !is_link($dir."/".$object))
		 {
           rrmdir($dir. DIRECTORY_SEPARATOR .$object);
		   printf("rrmdir: Deleted Folder: %s\n" , $dir. DIRECTORY_SEPARATOR .$object);
		 }
         else
		 {
           unlink($dir. DIRECTORY_SEPARATOR .$object);
		   printf("rrmdir: Deleted File: %s\n" , $dir. DIRECTORY_SEPARATOR .$object);
		 }
       } 
     }
     rmdir($dir); 
	 printf("rrmdir #1: Deteled Folder: %s\n" , $dir);
   } 
}
 
/**
 * Function: sanitize
 * Returns a sanitized string, typically for URLs.
 *
 * Parameters:
 *     $string - The string to sanitize.
 *     $force_lowercase - Force the string to lowercase?
 *     $anal - If set to *true*, will remove all non-alphanumeric characters.
 */
function sanitize($string, $force_lowercase = true, $anal = false) {
    $strip = array("~", "`", "!", "@", "#", "$", "%", "^", "&", "*", "(", ")", "_", "=", "+", "[", "{", "]",
                   "}", "\\", "|", ";", ":", "\"", "'", "&#8216;", "&#8217;", "&#8220;", "&#8221;", "&#8211;", "&#8212;",
                   ",", "<", ".", ">", "/", "?");
    $clean = trim(str_replace($strip, "", strip_tags($string)));
    $clean = preg_replace('/\s+/', "-", $clean);
    $clean = ($anal) ? preg_replace("/[^a-zA-Z0-9]/", "", $clean) : $clean ;
    return ($force_lowercase) ?
        (function_exists('mb_strtolower')) ?
            mb_strtolower($clean, 'UTF-8') :
            strtolower($clean) :
        $clean;
}
function ConvertEncoding($string)
{
    //根据系统进行配置
    $encode = stristr(PHP_OS, 'WIN') ? 'GBK' : 'UTF-8';
    $string = iconv('UTF-8', $encode, $string);
    //$string = mb_convert_encoding($string, $encode, 'UTF-8');
    return $string;
}
function filesize_formatted($bytes)
{
    if ($bytes >= 1073741824) {
        return number_format($bytes / 1073741824, 2) . ' GB';
    } elseif ($bytes >= 1048576) {
        return number_format($bytes / 1048576, 2) . ' MB';
    } elseif ($bytes >= 1024) {
        return number_format($bytes / 1024, 2) . ' KB';
    } elseif ($bytes > 1) {
        return $bytes . ' bytes';
    } elseif ($bytes == 1) {
        return '1 byte';
    } else {
        return '0 bytes';
    }
}

function pathToURL($path)
{
	//Replace backslashes to slashes if exists, because no URL use backslashes
	$path = str_replace("\\", "/", realpath($path));

	$strRoot = rtrim($_SERVER['DOCUMENT_ROOT'], DIRECTORY_SEPARATOR);
	//if the $path does not contain the document root in it, then it is not reachable
	$pos = strpos($path, $strRoot);
	if ($pos === false) return false;

	//just cut the DOCUMENT_ROOT part of the $path
	return substr($path, strlen($strRoot));
	//Note: usually /images is the same with http://somedomain.com/images,
	//      So let's not bother adding domain name here.
}

function get_value($array, $index, $default = '')
{
    if( !isset($array[$index]) )
    		return $default;
    //if( empty($array[$index]) )
    //		return $default;
    $value = trim($array[$index]);
    if( strlen($value) <= 0)
        return $default;
    return $value;
}

function GetClientIP($validate = False) {
  $ipkeys = array(
  'REMOTE_ADDR',
  'HTTP_CLIENT_IP',
  'HTTP_X_FORWARDED_FOR',
  'HTTP_X_FORWARDED',
  'HTTP_FORWARDED_FOR',
  'HTTP_FORWARDED',
  'HTTP_X_CLUSTER_CLIENT_IP'
  );

  /*
  Now we check each key against $_SERVER if containing such value
  */
  $ip = array();
  foreach ($ipkeys as $keyword) {
    if (isset($_SERVER[$keyword])) {
      if ($validate) {
        if (ValidatePublicIP($_SERVER[$keyword])) {
          $ip[] = $_SERVER[$keyword];
        }
      }
      else{
        $ip[] = $_SERVER[$keyword];
      }
    }
  }

  $ip = ( empty($ip) ? 'Unknown' : implode(", ", $ip) );
  return $ip;
}

function ValidatePublicIP($ip){
  if (filter_var($ip, FILTER_VALIDATE_IP, FILTER_FLAG_NO_PRIV_RANGE | FILTER_FLAG_NO_RES_RANGE)) {
    return true;
  }
  else {
    return false;
  }
}

function strToHex($string){
    $hex = '';
    for ($i=0; $i<strlen($string); $i++){
        $ord = ord($string[$i]);
        $hexCode = dechex($ord);
        $hex .= substr('0'.$hexCode, -2);
    }
    return strToUpper($hex);
}
function hexToStr($hex){
    $string='';
    for ($i=0; $i < strlen($hex)-1; $i+=2){
        $string .= chr(hexdec($hex[$i].$hex[$i+1]));
    }
    return $string;
}

?>
